diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/non-ht/dsss-phy.cc ns-3.34/src/wifi/model/non-ht/dsss-phy.cc
--- ns-3.33/src/wifi/model/non-ht/dsss-phy.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/non-ht/dsss-phy.cc	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,390 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Orange Labs
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Rediet <getachew.redieteab@orange.com>
+ *          Sébastien Deronne <sebastien.deronne@gmail.com> (for logic ported from wifi-phy)
+ *          Mathieu Lacage <mathieu.lacage@sophia.inria.fr> (for logic ported from wifi-phy)
+ */
+
+#include <array>
+#include "dsss-phy.h"
+#include "dsss-ppdu.h"
+#include "ns3/wifi-psdu.h"
+#include "ns3/wifi-phy.h" //only used for static mode constructor
+#include "ns3/wifi-utils.h"
+#include "ns3/simulator.h"
+#include "ns3/log.h"
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("DsssPhy");
+
+/*******************************************************
+ *       HR/DSSS PHY (IEEE 802.11-2016, clause 16)
+ *******************************************************/
+
+/* *NS_CHECK_STYLE_OFF* */
+const PhyEntity::PpduFormats DsssPhy::m_dsssPpduFormats {
+  { WIFI_PREAMBLE_LONG,  { WIFI_PPDU_FIELD_PREAMBLE,      //PHY preamble
+                           WIFI_PPDU_FIELD_NON_HT_HEADER, //PHY header
+                           WIFI_PPDU_FIELD_DATA } },
+  { WIFI_PREAMBLE_SHORT, { WIFI_PPDU_FIELD_PREAMBLE,      //Short PHY preamble
+                           WIFI_PPDU_FIELD_NON_HT_HEADER, //Short PHY header
+                           WIFI_PPDU_FIELD_DATA } }
+};
+
+const PhyEntity::ModulationLookupTable DsssPhy::m_dsssModulationLookupTable {
+  // Unique name         Code rate                 Constellation size
+  { "DsssRate1Mbps",   { WIFI_CODE_RATE_UNDEFINED, 2 } },
+  { "DsssRate2Mbps",   { WIFI_CODE_RATE_UNDEFINED, 4 } },
+  { "DsssRate5_5Mbps", { WIFI_CODE_RATE_UNDEFINED, 16 } },
+  { "DsssRate11Mbps",  { WIFI_CODE_RATE_UNDEFINED, 256 } }
+};
+/* *NS_CHECK_STYLE_ON* */
+
+/// DSSS rates in bits per second
+static const std::array<uint64_t, 4> s_dsssRatesBpsList = {1000000,  2000000, 5500000, 11000000};
+
+/**
+ * Get the array of possible DSSS rates.
+ *
+ * \return the DSSS rates in bits per second
+ */
+const std::array<uint64_t, 4>& GetDsssRatesBpsList (void)
+{
+  return s_dsssRatesBpsList;
+};
+
+DsssPhy::DsssPhy ()
+{
+  NS_LOG_FUNCTION (this);
+  for (const auto & rate : GetDsssRatesBpsList ())
+    {
+      WifiMode mode = GetDsssRate (rate);
+      NS_LOG_LOGIC ("Add " << mode << " to list");
+      m_modeList.emplace_back (mode);
+    }
+}
+
+DsssPhy::~DsssPhy ()
+{
+  NS_LOG_FUNCTION (this);
+}
+
+WifiMode
+DsssPhy::GetSigMode (WifiPpduField field, const WifiTxVector& txVector) const
+{
+  switch (field)
+    {
+      case WIFI_PPDU_FIELD_PREAMBLE: //consider header mode for preamble (useful for InterferenceHelper)
+      case WIFI_PPDU_FIELD_NON_HT_HEADER:
+        return GetHeaderMode (txVector);
+      default:
+        return PhyEntity::GetSigMode (field, txVector);
+    }
+}
+
+WifiMode
+DsssPhy::GetHeaderMode (const WifiTxVector& txVector) const
+{
+  if (txVector.GetPreambleType () == WIFI_PREAMBLE_LONG
+      || txVector.GetMode () == GetDsssRate1Mbps ())
+    {
+      //Section 16.2.3 "PPDU field definitions" and Section 16.2.2.2 "Long PPDU format"; IEEE Std 802.11-2016
+      return GetDsssRate1Mbps ();
+    }
+  else
+    {
+      //Section 16.2.2.3 "Short PPDU format"; IEEE Std 802.11-2016
+      return GetDsssRate2Mbps ();
+    }
+}
+
+const PhyEntity::PpduFormats &
+DsssPhy::GetPpduFormats (void) const
+{
+  return m_dsssPpduFormats;
+}
+
+Time
+DsssPhy::GetDuration (WifiPpduField field, const WifiTxVector& txVector) const
+{
+  if (field == WIFI_PPDU_FIELD_PREAMBLE)
+    {
+      return GetPreambleDuration (txVector); //SYNC + SFD or shortSYNC + shortSFD
+    }
+  else if (field == WIFI_PPDU_FIELD_NON_HT_HEADER)
+    {
+      return GetHeaderDuration (txVector); //PHY header or short PHY header
+    }
+  else
+    {
+      return PhyEntity::GetDuration (field, txVector);
+    }
+}
+
+Time
+DsssPhy::GetPreambleDuration (const WifiTxVector& txVector) const
+{
+  if (txVector.GetPreambleType () == WIFI_PREAMBLE_SHORT
+      && (txVector.GetMode ().GetDataRate (22) > 1000000))
+    {
+      //Section 16.2.2.3 "Short PPDU format" Figure 16-2 "Short PPDU format"; IEEE Std 802.11-2016
+      return MicroSeconds (72);
+    }
+  else
+    {
+      //Section 16.2.2.2 "Long PPDU format" Figure 16-1 "Long PPDU format"; IEEE Std 802.11-2016
+      return MicroSeconds (144);
+    }
+}
+
+Time
+DsssPhy::GetHeaderDuration (const WifiTxVector& txVector) const
+{
+  if (txVector.GetPreambleType () == WIFI_PREAMBLE_SHORT
+      && (txVector.GetMode ().GetDataRate (22) > 1000000))
+    {
+      //Section 16.2.2.3 "Short PPDU format" and Figure 16-2 "Short PPDU format"; IEEE Std 802.11-2016
+      return MicroSeconds (24);
+    }
+  else
+    {
+      //Section 16.2.2.2 "Long PPDU format" and Figure 16-1 "Short PPDU format"; IEEE Std 802.11-2016
+      return MicroSeconds (48);
+    }
+}
+
+Time
+DsssPhy::GetPayloadDuration (uint32_t size, const WifiTxVector& txVector, WifiPhyBand /* band */, MpduType /* mpdutype */,
+                             bool /* incFlag */, uint32_t & /* totalAmpduSize */, double & /* totalAmpduNumSymbols */,
+                             uint16_t /* staId */) const
+{
+  return MicroSeconds (lrint (ceil ((size * 8.0) / (txVector.GetMode ().GetDataRate (22) / 1.0e6))));
+}
+
+Ptr<WifiPpdu>
+DsssPhy::BuildPpdu (const WifiConstPsduMap & psdus, const WifiTxVector& txVector, Time ppduDuration)
+{
+  NS_LOG_FUNCTION (this << psdus << txVector << ppduDuration);
+  return Create<DsssPpdu> (psdus.begin ()->second, txVector, ppduDuration,
+                           ObtainNextUid (txVector));
+}
+
+PhyEntity::PhyFieldRxStatus
+DsssPhy::DoEndReceiveField (WifiPpduField field, Ptr<Event> event)
+{
+  NS_LOG_FUNCTION (this << field << *event);
+  if (field == WIFI_PPDU_FIELD_NON_HT_HEADER)
+    {
+      return EndReceiveHeader (event); //PHY header or short PHY header
+    }
+  return PhyEntity::DoEndReceiveField (field, event);
+}
+
+PhyEntity::PhyFieldRxStatus
+DsssPhy::EndReceiveHeader (Ptr<Event> event)
+{
+  NS_LOG_FUNCTION (this << *event);
+  SnrPer snrPer = GetPhyHeaderSnrPer (WIFI_PPDU_FIELD_NON_HT_HEADER, event);
+  NS_LOG_DEBUG ("Long/Short PHY header: SNR(dB)=" << RatioToDb (snrPer.snr) << ", PER=" << snrPer.per);
+  PhyFieldRxStatus status (GetRandomValue () > snrPer.per);
+  if (status.isSuccess)
+    {
+      NS_LOG_DEBUG ("Received long/short PHY header");
+      if (!IsConfigSupported (event->GetPpdu ()))
+        {
+          status = PhyFieldRxStatus (false, UNSUPPORTED_SETTINGS, DROP);
+        }
+    }
+  else
+    {
+      NS_LOG_DEBUG ("Abort reception because long/short PHY header reception failed");
+      status.reason = L_SIG_FAILURE;
+      status.actionIfFailure = ABORT;
+    }
+  return status;
+}
+
+uint16_t
+DsssPhy::GetRxChannelWidth (const WifiTxVector& txVector) const
+{
+  if (m_wifiPhy->GetChannelWidth () > 20)
+    {
+      /*
+       * This is a workaround necessary with HE-capable PHYs,
+       * since their DSSS entity will reuse its RxSpectrumModel.
+       * Without this hack, SpectrumWifiPhy::GetBand will crash.
+       * FIXME: see issue #402 for a better solution.
+       */
+      return 20;
+    }
+  return PhyEntity::GetRxChannelWidth (txVector);
+}
+
+Ptr<SpectrumValue>
+DsssPhy::GetTxPowerSpectralDensity (double txPowerW, Ptr<const WifiPpdu> ppdu) const
+{
+  const WifiTxVector& txVector = ppdu->GetTxVector ();
+  uint16_t centerFrequency = GetCenterFrequencyForChannelWidth (txVector);
+  uint16_t channelWidth = txVector.GetChannelWidth ();
+  NS_LOG_FUNCTION (this << centerFrequency << channelWidth << txPowerW);
+  NS_ABORT_MSG_IF (channelWidth != 22, "Invalid channel width for DSSS");
+  Ptr<SpectrumValue> v = WifiSpectrumValueHelper::CreateDsssTxPowerSpectralDensity (centerFrequency, txPowerW, GetGuardBandwidth (channelWidth));
+  return v;
+}
+
+void
+DsssPhy::InitializeModes (void)
+{
+  for (const auto & rate : GetDsssRatesBpsList ())
+    {
+      GetDsssRate (rate);
+    }
+}
+
+WifiMode
+DsssPhy::GetDsssRate (uint64_t rate)
+{
+  switch (rate)
+    {
+      case 1000000:
+        return GetDsssRate1Mbps ();
+      case 2000000:
+        return GetDsssRate2Mbps ();
+      case 5500000:
+        return GetDsssRate5_5Mbps ();
+      case 11000000:
+        return GetDsssRate11Mbps ();
+      default:
+        NS_ABORT_MSG ("Inexistent rate (" << rate << " bps) requested for HR/DSSS");
+        return WifiMode ();
+    }
+}
+
+#define GET_DSSS_MODE(x, m) \
+WifiMode \
+DsssPhy::Get ## x (void) \
+{ \
+  static WifiMode mode = CreateDsssMode (#x, WIFI_MOD_CLASS_ ## m); \
+  return mode; \
+}; \
+
+// Clause 15 rates (DSSS)
+GET_DSSS_MODE (DsssRate1Mbps,   DSSS)
+GET_DSSS_MODE (DsssRate2Mbps,   DSSS)
+// Clause 16 rates (HR/DSSS)
+GET_DSSS_MODE (DsssRate5_5Mbps, HR_DSSS)
+GET_DSSS_MODE (DsssRate11Mbps,  HR_DSSS)
+#undef GET_DSSS_MODE
+
+WifiMode
+DsssPhy::CreateDsssMode (std::string uniqueName,
+                         WifiModulationClass modClass)
+{
+  // Check whether uniqueName is in lookup table
+  const auto it = m_dsssModulationLookupTable.find (uniqueName);
+  NS_ASSERT_MSG (it != m_dsssModulationLookupTable.end (), "DSSS or HR/DSSS mode cannot be created because it is not in the lookup table!");
+  NS_ASSERT_MSG (modClass == WIFI_MOD_CLASS_DSSS || modClass == WIFI_MOD_CLASS_HR_DSSS, "DSSS or HR/DSSS mode must be either WIFI_MOD_CLASS_DSSS or WIFI_MOD_CLASS_HR_DSSS!");
+
+  return WifiModeFactory::CreateWifiMode (uniqueName,
+                                          modClass,
+                                          true,
+                                          MakeBoundCallback (&GetCodeRate, uniqueName),
+                                          MakeBoundCallback (&GetConstellationSize, uniqueName),
+                                          MakeBoundCallback (&GetDataRate, uniqueName, modClass), //PhyRate is equivalent to DataRate
+                                          MakeCallback (&GetDataRateFromTxVector), //PhyRate is equivalent to DataRate
+                                          MakeBoundCallback (&GetDataRate, uniqueName, modClass),
+                                          MakeCallback (&GetDataRateFromTxVector),
+                                          MakeCallback (&IsModeAllowed));
+}
+
+WifiCodeRate
+DsssPhy::GetCodeRate (const std::string& name)
+{
+  return m_dsssModulationLookupTable.at (name).first;
+}
+
+uint16_t
+DsssPhy::GetConstellationSize (const std::string& name)
+{
+  return m_dsssModulationLookupTable.at (name).second;
+}
+
+uint64_t
+DsssPhy::GetDataRateFromTxVector (const WifiTxVector& txVector, uint16_t /* staId */)
+{
+  WifiMode mode = txVector.GetMode ();
+  return DsssPhy::GetDataRate (mode.GetUniqueName (),
+                               mode.GetModulationClass (),
+                               22, 0, 1); //dummy values since unused
+}
+
+uint64_t
+DsssPhy::GetDataRate (const std::string& name, WifiModulationClass modClass, uint16_t /* channelWidth */, uint16_t /* guardInterval */, uint8_t /* nss */)
+{
+  uint16_t constellationSize = GetConstellationSize (name);
+  uint16_t divisor = 0;
+  if (modClass == WIFI_MOD_CLASS_DSSS)
+    {
+      divisor = 11;
+    }
+  else if (modClass == WIFI_MOD_CLASS_HR_DSSS)
+    {
+      divisor = 8;
+    }
+  else
+    {
+      NS_FATAL_ERROR ("Incorrect modulation class, must specify either WIFI_MOD_CLASS_DSSS or WIFI_MOD_CLASS_HR_DSSS!");
+    }
+  uint16_t numberOfBitsPerSubcarrier = static_cast<uint16_t> (log2 (constellationSize));
+  uint64_t dataRate = ((11000000 / divisor) * numberOfBitsPerSubcarrier);
+  return dataRate;
+}
+
+bool
+DsssPhy::IsModeAllowed (uint16_t /* channelWidth */, uint8_t /* nss */)
+{
+  return true;
+}
+
+uint32_t
+DsssPhy::GetMaxPsduSize (void) const
+{
+  return 4095;
+}
+
+} //namespace ns3
+
+namespace {
+
+/**
+ * Constructor class for DSSS modes
+ */
+static class ConstructorDsss
+{
+public:
+  ConstructorDsss ()
+  {
+    ns3::DsssPhy::InitializeModes ();
+    ns3::Ptr<ns3::DsssPhy> phyEntity = ns3::Create<ns3::DsssPhy> ();
+    ns3::WifiPhy::AddStaticPhyEntity (ns3::WIFI_MOD_CLASS_HR_DSSS, phyEntity);
+    ns3::WifiPhy::AddStaticPhyEntity (ns3::WIFI_MOD_CLASS_DSSS, phyEntity); //use same entity when plain DSSS modes are used
+  }
+} g_constructor_dsss; ///< the constructor for DSSS modes
+
+}
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/non-ht/dsss-phy.h ns-3.34/src/wifi/model/non-ht/dsss-phy.h
--- ns-3.33/src/wifi/model/non-ht/dsss-phy.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/non-ht/dsss-phy.h	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,208 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Orange Labs
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Rediet <getachew.redieteab@orange.com>
+ *          Sébastien Deronne <sebastien.deronne@gmail.com> (for logic ported from wifi-phy)
+ *          Mathieu Lacage <mathieu.lacage@sophia.inria.fr> (for logic ported from wifi-phy)
+ */
+
+#ifndef DSSS_PHY_H
+#define DSSS_PHY_H
+
+#include "ns3/phy-entity.h"
+#include <vector>
+
+/**
+ * \file
+ * \ingroup wifi
+ * Declaration of ns3::DsssPhy class.
+ */
+
+namespace ns3 {
+
+/**
+ * \brief PHY entity for HR/DSSS (11b)
+ * \ingroup wifi
+ *
+ * Refer to IEEE 802.11-2016, clause 16 (HR/DSSS).
+ * Note that DSSS rates (clause 15) are a subset
+ * of HR/DSSS rates.
+ */
+class DsssPhy : public PhyEntity
+{
+public:
+  /**
+   * Constructor for HR/DSSS PHY
+   */
+  DsssPhy ();
+  /**
+   * Destructor for HR/DSSS PHY
+   */
+  virtual ~DsssPhy ();
+
+  WifiMode GetSigMode (WifiPpduField field, const WifiTxVector& txVector) const override;
+  const PpduFormats & GetPpduFormats (void) const override;
+  Time GetDuration (WifiPpduField field, const WifiTxVector& txVector) const override;
+  Time GetPayloadDuration (uint32_t size, const WifiTxVector& txVector, WifiPhyBand band, MpduType mpdutype,
+                           bool incFlag, uint32_t &totalAmpduSize, double &totalAmpduNumSymbols,
+                           uint16_t staId) const override;
+  Ptr<WifiPpdu> BuildPpdu (const WifiConstPsduMap & psdus, const WifiTxVector& txVector, Time ppduDuration) override;
+  uint32_t GetMaxPsduSize (void) const override;
+
+  /**
+   * Initialize all HR/DSSS modes.
+   */
+  static void InitializeModes (void);
+  /**
+   * Return a WifiMode for HR/DSSS
+   * corresponding to the provided rate.
+   *
+   * \param rate the rate in bps
+   * \return a WifiMode for HR/DSSS
+   */
+  static WifiMode GetDsssRate (uint64_t rate);
+  /**
+   * Return a WifiMode for DSSS at 1 Mbps.
+   *
+   * \return a WifiMode for DSSS at 1 Mbps
+   */
+  static WifiMode GetDsssRate1Mbps (void);
+  /**
+   * Return a WifiMode for DSSS at 2 Mbps.
+   *
+   * \return a WifiMode for DSSS at 2 Mbps
+   */
+  static WifiMode GetDsssRate2Mbps (void);
+  /**
+   * Return a WifiMode for HR/DSSS at 5.5 Mbps.
+   *
+   * \return a WifiMode for HR/DSSS at 5.5 Mbps
+   */
+  static WifiMode GetDsssRate5_5Mbps (void);
+  /**
+   * Return a WifiMode for HR/DSSS at 11 Mbps.
+   *
+   * \return a WifiMode for HR/DSSS at 11 Mbps
+   */
+  static WifiMode GetDsssRate11Mbps (void);
+
+  /**
+   * Return the WifiCodeRate from the DSSS or HR/DSSS mode's unique
+   * name using ModulationLookupTable. This is mainly used as a
+   * callback for WifiMode operation.
+   *
+   * \param name the unique name of the DSSS or HR/DSSS mode
+   * \return WifiCodeRate corresponding to the unique name
+   */
+  static WifiCodeRate GetCodeRate (const std::string& name);
+  /**
+   * Return the constellation size from the DSSS or HR/DSSS mode's
+   * unique name using ModulationLookupTable. This is mainly used
+   * as a callback for WifiMode operation.
+   *
+   * \param name the unique name of the DSSS or HR/DSSS mode
+   * \return constellation size corresponding to the unique name
+   */
+  static uint16_t GetConstellationSize (const std::string& name);
+  /**
+   * Return the data rate corresponding to
+   * the supplied TXVECTOR.
+   * This function is mainly used as a callback
+   * for WifiMode operation.
+   *
+   * \param txVector the TXVECTOR used for the transmission
+   * \param staId the station ID (only here to have a common signature for all callbacks)
+   * \return the data bit rate in bps.
+   */
+  static uint64_t GetDataRateFromTxVector (const WifiTxVector& txVector, uint16_t staId);
+  /**
+   * Return the data rate from the DSSS or HR/DSSS mode's unique name and
+   * the supplied parameters. This function is mainly used as a callback
+   * for WifiMode operation.
+   *
+   * \param name the unique name of the DSSS or HR/DSSS mode
+   * \param modClass the modulation class, must be either WIFI_MOD_CLASS_DSSS or WIFI_MOD_CLASS_HR_DSSS
+   * \param channelWidth the considered channel width in MHz
+   * \param guardInterval the considered guard interval duration in nanoseconds
+   * \param nss the considered number of streams
+   *
+   * \return the data bit rate of this signal in bps.
+   */
+  static uint64_t GetDataRate (const std::string& name, WifiModulationClass modClass, uint16_t channelWidth, uint16_t guardInterval, uint8_t nss);
+  /**
+   * Check whether the combination of <WifiMode, channel width, NSS> is allowed.
+   * This function is used as a callback for WifiMode operation, and always
+   * returns true since there is no limitation for any mode in DsssPhy.
+   *
+   * \param channelWidth the considered channel width in MHz
+   * \param nss the considered number of streams
+   * \returns true.
+   */
+  static bool IsModeAllowed (uint16_t channelWidth, uint8_t nss);
+
+private:
+  PhyFieldRxStatus DoEndReceiveField (WifiPpduField field, Ptr<Event> event) override;
+  Ptr<SpectrumValue> GetTxPowerSpectralDensity (double txPowerW, Ptr<const WifiPpdu> ppdu) const override;
+  uint16_t GetRxChannelWidth (const WifiTxVector& txVector) const override;
+
+  /**
+   * \param txVector the transmission parameters
+   * \return the WifiMode used for the PHY header field
+   */
+  WifiMode GetHeaderMode (const WifiTxVector& txVector) const;
+
+  /**
+   * \param txVector the transmission parameters
+   * \return the duration of the PHY preamble field
+   *
+   * \see WIFI_PPDU_FIELD_PREAMBLE
+   */
+  Time GetPreambleDuration (const WifiTxVector& txVector) const;
+  /**
+   * \param txVector the transmission parameters
+   * \return the duration of the PHY header field
+   */
+  Time GetHeaderDuration (const WifiTxVector& txVector) const;
+
+  /**
+   * End receiving the header, perform DSSS-specific actions, and
+   * provide the status of the reception.
+   *
+   * \param event the event holding incoming PPDU's information
+   * \return status of the reception of the header
+   */
+  PhyFieldRxStatus EndReceiveHeader (Ptr<Event> event);
+
+  /**
+   * Create a DSSS or HR/DSSS mode from a unique name, the unique name
+   * must already be contained inside ModulationLookupTable.
+   * This method binds all the callbacks used by WifiMode.
+   *
+   * \param uniqueName the unique name of the WifiMode
+   * \param modClass the modulation class of the WifiMode, must be either WIFI_MOD_CLASS_DSSS or WIFI_MOD_CLASS_HR_DSSS
+   * \return the DSSS or HR/DSSS WifiMode
+   */
+  static WifiMode CreateDsssMode (std::string uniqueName, WifiModulationClass modClass);
+
+  static const PpduFormats m_dsssPpduFormats; //!< DSSS and HR/DSSS PPDU formats
+
+  static const ModulationLookupTable m_dsssModulationLookupTable; //!< lookup table to retrieve code rate and constellation size corresponding to a unique name of modulation
+}; //class DsssPhy
+
+} //namespace ns3
+
+#endif /* DSSS_PHY_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/non-ht/dsss-ppdu.cc ns-3.34/src/wifi/model/non-ht/dsss-ppdu.cc
--- ns-3.33/src/wifi/model/non-ht/dsss-ppdu.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/non-ht/dsss-ppdu.cc	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,197 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Orange Labs
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Rediet <getachew.redieteab@orange.com>
+ *         Muhammad Iqbal Rochman <muhiqbalcr@uchicago.edu>
+ *         Sébastien Deronne <sebastien.deronne@gmail.com> (DsssSigHeader)
+ */
+
+#include "ns3/wifi-phy.h"
+#include "ns3/wifi-psdu.h"
+#include "dsss-phy.h"
+#include "dsss-ppdu.h"
+#include "ns3/log.h"
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("DsssPpdu");
+
+DsssPpdu::DsssPpdu (Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector, Time ppduDuration, uint64_t uid)
+  : WifiPpdu (psdu, txVector, uid)
+{
+  NS_LOG_FUNCTION (this << psdu << txVector << ppduDuration << uid);
+  m_dsssSig.SetRate (txVector.GetMode ().GetDataRate (22));
+  Time psduDuration = ppduDuration - WifiPhy::CalculatePhyPreambleAndHeaderDuration (txVector);
+  m_dsssSig.SetLength (psduDuration.GetMicroSeconds ());
+}
+
+DsssPpdu::~DsssPpdu ()
+{
+}
+
+WifiTxVector
+DsssPpdu::DoGetTxVector (void) const
+{
+  WifiTxVector txVector;
+  txVector.SetPreambleType (m_preamble);
+  txVector.SetMode (DsssPhy::GetDsssRate (m_dsssSig.GetRate ()));
+  txVector.SetChannelWidth (22);
+  return txVector;
+}
+
+Time
+DsssPpdu::GetTxDuration (void) const
+{
+  Time ppduDuration = Seconds (0);
+  const WifiTxVector& txVector = GetTxVector ();
+  ppduDuration = MicroSeconds (m_dsssSig.GetLength ()) + WifiPhy::CalculatePhyPreambleAndHeaderDuration (txVector);
+  return ppduDuration;
+}
+
+Ptr<WifiPpdu>
+DsssPpdu::Copy (void) const
+{
+  return Create<DsssPpdu> (GetPsdu (), GetTxVector (), GetTxDuration (), m_uid);
+}
+
+DsssPpdu::DsssSigHeader::DsssSigHeader ()
+  : m_rate (0b00001010),
+    m_length (0)
+{
+}
+
+DsssPpdu::DsssSigHeader::~DsssSigHeader ()
+{
+}
+
+TypeId
+DsssPpdu::DsssSigHeader::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::DsssSigHeader")
+    .SetParent<Header> ()
+    .SetGroupName ("Wifi")
+    .AddConstructor<DsssSigHeader> ()
+  ;
+  return tid;
+}
+
+TypeId
+DsssPpdu::DsssSigHeader::GetInstanceTypeId (void) const
+{
+  return GetTypeId ();
+}
+
+void
+DsssPpdu::DsssSigHeader::Print (std::ostream &os) const
+{
+  os << "SIGNAL=" << GetRate ()
+     << " LENGTH=" << m_length;
+}
+
+uint32_t
+DsssPpdu::DsssSigHeader::GetSerializedSize (void) const
+{
+  return 6;
+}
+
+void
+DsssPpdu::DsssSigHeader::SetRate (uint64_t rate)
+{
+  /* Here is the binary representation for a given rate:
+   * 1 Mbit/s: 00001010
+   * 2 Mbit/s: 00010100
+   * 5.5 Mbit/s: 00110111
+   * 11 Mbit/s: 01101110
+   */
+  switch (rate)
+    {
+      case 1000000:
+        m_rate = 0b00001010;
+        break;
+      case 2000000:
+        m_rate = 0b00010100;
+        break;
+      case 5500000:
+        m_rate = 0b00110111;
+        break;
+      case 11000000:
+        m_rate = 0b01101110;
+        break;
+      default:
+        NS_ASSERT_MSG (false, "Invalid rate");
+        break;
+    }
+}
+
+uint64_t
+DsssPpdu::DsssSigHeader::GetRate (void) const
+{
+  uint64_t rate = 0;
+  switch (m_rate)
+    {
+      case 0b00001010:
+        rate = 1000000;
+        break;
+      case 0b00010100:
+        rate = 2000000;
+        break;
+      case 0b00110111:
+        rate = 5500000;
+        break;
+      case 0b01101110:
+        rate = 11000000;
+        break;
+      default:
+        NS_ASSERT_MSG (false, "Invalid rate");
+        break;
+    }
+  return rate;
+}
+
+void
+DsssPpdu::DsssSigHeader::SetLength (uint16_t length)
+{
+  m_length = length;
+}
+
+uint16_t
+DsssPpdu::DsssSigHeader::GetLength (void) const
+{
+  return m_length;
+}
+
+void
+DsssPpdu::DsssSigHeader::Serialize (Buffer::Iterator start) const
+{
+  start.WriteU8 (m_rate);
+  start.WriteU8 (0); /* SERVICE */
+  start.WriteU16 (m_length);
+  start.WriteU16 (0); /* CRC */
+}
+
+uint32_t
+DsssPpdu::DsssSigHeader::Deserialize (Buffer::Iterator start)
+{
+  Buffer::Iterator i = start;
+  m_rate = i.ReadU8 ();
+  i.ReadU8 (); /* SERVICE */
+  m_length =  i.ReadU16 ();
+  i.ReadU16 (); /* CRC */
+  return i.GetDistanceFrom (start);
+}
+
+} //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/non-ht/dsss-ppdu.h ns-3.34/src/wifi/model/non-ht/dsss-ppdu.h
--- ns-3.33/src/wifi/model/non-ht/dsss-ppdu.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/non-ht/dsss-ppdu.h	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,126 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Orange Labs
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Rediet <getachew.redieteab@orange.com>
+ *         Muhammad Iqbal Rochman <muhiqbalcr@uchicago.edu>
+ *         Sébastien Deronne <sebastien.deronne@gmail.com> (DsssSigHeader)
+ */
+
+#ifndef DSSS_PPDU_H
+#define DSSS_PPDU_H
+
+#include "ns3/wifi-ppdu.h"
+#include "ns3/header.h"
+
+/**
+ * \file
+ * \ingroup wifi
+ * Declaration of ns3::DsssPpdu class.
+ */
+
+namespace ns3 {
+
+class WifiPsdu;
+
+/**
+ * \brief DSSS (HR/DSSS) PPDU (11b)
+ * \ingroup wifi
+ *
+ * DsssPpdu stores a preamble, PHY headers and a PSDU of a PPDU with DSSS modulation.
+ */
+class DsssPpdu : public WifiPpdu
+{
+public:
+
+  /**
+   * DSSS SIG PHY header.
+   * See section 16.2.2 in IEEE 802.11-2016.
+   */
+  class DsssSigHeader : public Header
+  {
+  public:
+    DsssSigHeader ();
+    virtual ~DsssSigHeader ();
+
+    /**
+     * \brief Get the type ID.
+     * \return the object TypeId
+     */
+    static TypeId GetTypeId (void);
+
+    TypeId GetInstanceTypeId (void) const override;
+    void Print (std::ostream &os) const override;
+    uint32_t GetSerializedSize (void) const override;
+    void Serialize (Buffer::Iterator start) const override;
+    uint32_t Deserialize (Buffer::Iterator start) override;
+
+    /**
+     * Fill the RATE field of L-SIG (in bit/s).
+     *
+     * \param rate the RATE field of L-SIG expressed in bit/s
+     */
+    void SetRate (uint64_t rate);
+    /**
+     * Return the RATE field of L-SIG (in bit/s).
+     *
+     * \return the RATE field of L-SIG expressed in bit/s
+     */
+    uint64_t GetRate (void) const;
+    /**
+     * Fill the LENGTH field of L-SIG (in bytes).
+     *
+     * \param length the LENGTH field of L-SIG expressed in bytes
+     */
+    void SetLength (uint16_t length);
+    /**
+     * Return the LENGTH field of L-SIG (in bytes).
+     *
+     * \return the LENGTH field of L-SIG expressed in bytes
+     */
+    uint16_t GetLength (void) const;
+
+  private:
+    uint8_t m_rate;    ///< RATE field
+    uint16_t m_length; ///< LENGTH field
+  }; //class DsssSigHeader
+
+  /**
+   * Create a DSSS (HR/DSSS) PPDU.
+   *
+   * \param psdu the PHY payload (PSDU)
+   * \param txVector the TXVECTOR that was used for this PPDU
+   * \param ppduDuration the transmission duration of this PPDU
+   * \param uid the unique ID of this PPDU
+   */
+  DsssPpdu (Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector, Time ppduDuration, uint64_t uid);
+  /**
+   * Destructor for DsssPpdu.
+   */
+  virtual ~DsssPpdu ();
+
+  Time GetTxDuration (void) const override;
+  Ptr<WifiPpdu> Copy (void) const override;
+
+private:
+  WifiTxVector DoGetTxVector (void) const override;
+
+  DsssSigHeader m_dsssSig;  //!< the DSSS SIG PHY header
+}; //class DsssPpdu
+
+} //namespace ns3
+
+#endif /* DSSS_PPDU_H */
